## mariadb 12.2.2+maria~ubu2204

=== sql/CMakeLists.txt ===
# Copyright (c) 2006, 2014, Oracle and/or its affiliates.
# Copyright (c) 2010, 2022, MariaDB Corporation.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1335 USA


IF(WITH_WSREP AND NOT EMBEDDED_LIBRARY)
  SET(WSREP_SOURCES
    wsrep_client_service.cc
    wsrep_high_priority_service.cc
    wsrep_server_service.cc
    wsrep_storage_service.cc
    wsrep_server_state.cc
    wsrep_event_service.cc
    wsrep_status.cc
    wsrep_allowlist_service.cc
    wsrep_utils.cc
    wsrep_xid.cc
    wsrep_check_opts.cc
    wsrep_mysqld.cc
    wsrep_notify.cc
    wsrep_sst.cc
    wsrep_var.cc
    wsrep_binlog.cc
    wsrep_applier.cc
    wsrep_thd.cc
    wsrep_schema.cc
    wsrep_plugin.cc
    service_wsrep.cc
    )
  MYSQL_ADD_PLUGIN(wsrep_provider ${WSREP_SOURCES} DEFAULT NOT_EMBEDDED LINK_LIBRARIES wsrep-lib wsrep_api_v26)
  MYSQL_ADD_PLUGIN(wsrep ${WSREP_SOURCES} MANDATORY NOT_EMBEDDED LINK_LIBRARIES wsrep-lib wsrep_api_v26)
  IF(VISIBILITY_HIDDEN_FLAG AND TARGET wsrep)
    # wsrep_info plugin needs some wsrep symbols from inside mysqld
    # we have to remove -fvisibility=hidden from wsrep
    GET_TARGET_PROPERTY(f wsrep COMPILE_FLAGS)
    STRING(REPLACE "${VISIBILITY_HIDDEN_FLAG}" "" f ${f})
    SET_TARGET_PROPERTIES(wsrep PROPERTIES COMPILE_FLAGS "${f}")
  ENDIF()
ELSE()
  ADD_LIBRARY(wsrep STATIC wsrep_dummy.cc)
  ADD_DEPENDENCIES(wsrep GenError)
ENDIF()

INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/include
${CMAKE_SOURCE_DIR}/sql
${LIBFMT_INCLUDE_DIR}
${PCRE_INCLUDE_DIRS}
${ZLIB_INCLUDE_DIRS}
${SSL_INCLUDE_DIRS}
${CMAKE_BINARY_DIR}/sql
)

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/lex_token.h
  COMMAND gen_lex_token > lex_token.h
  DEPENDS gen_lex_token
)

FIND_PACKAGE(BISON 2.4)

ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/yy_mariadb.yy
         ${CMAKE_CURRENT_BINARY_DIR}/yy_oracle.yy
  COMMAND ${CMAKE_COMMAND} "-DVAL1=ORACLE" "-DVAL2=MARIADB"
   "-DOUT1=${CMAKE_CURRENT_BINARY_DIR}/yy_oracle.yy"
   "-DOUT2=${CMAKE_CURRENT_BINARY_DIR}/yy_mariadb.yy"
   "-DIN=${CMAKE_CURRENT_SOURCE_DIR}/sql_yacc.yy"
    "-DBISON_VERSION=${BISON_VERSION}"
   -P ${CMAKE_CURRENT_SOURCE_DIR}/gen_yy_files.cmake
  COMMENT "Building yy_mariadb.yy and yy_oracle.yy from sql_yacc.yy"
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/sql_yacc.yy
          ${CMAKE_CURRENT_SOURCE_DIR}/gen_yy_files.cmake
)

ADD_DEFINITIONS(-DMYSQL_SERVER -DHAVE_EVENT_SCHEDULER)

IF(SSL_DEFINES)
 ADD_DEFINITIONS(${SSL_DEFINES})
ENDIF()

SET (SQL_SOURCE
               ${CMAKE_CURRENT_BINARY_DIR}/yy_mariadb.cc
               ${CMAKE_CURRENT_BINARY_DIR}/yy_oracle.cc
              ../sql-common/client.c
               cset_narrowing.cc
               compat56.cc derror.cc des_key_file.cc
               discover.cc ../sql-common/errmsg.c
               field.cc field_conv.cc field_comp.cc
               filesort_utils.cc
               filesort.cc gstream.cc
               signal_handler.cc
               handler.cc item_vectorfunc.cc
               hostname.cc init.cc item.cc item_buff.cc item_cmpfunc.cc
               item_create.cc item_func.cc item_geofunc.cc item_row.cc
               item_strfunc.cc item_subselect.cc item_sum.cc item_timefunc.cc
               item_numconvfunc.cc
               key.cc log.cc log_cache.cc lock.cc
               log_event.cc log_event_server.cc
               rpl_record.cc rpl_reporting.cc
               mf_iocache.cc my_decimal.cc
               mysqld.cc net_serv.cc  keycaches.cc
               ../sql-common/client_plugin.c
               opt_range.cc vector_mhnsw.cc
               opt_group_by_cardinality.cc
               opt_rewrite_date_cmp.cc
               opt_rewrite_remove_casefold.cc
               opt_sargable_left.cc
               opt_sum.cc
               opt_vcol_substitution.cc
               ../sql-common/pack.c parse_file.cc password.c procedure.cc
               protocol.cc records.cc repl_failsafe.cc rpl_filter.cc
               session_tracker.cc
               set_var.cc
               slave.cc sp.cc sp_cache.cc sp_head.cc sp_pcontext.cc
               sp_rcontext.cc sp_cursor.cc
               spatial.cc sql_acl.cc sql_analyse.cc sql_base.cc
               sql_cache.cc sql_class.cc sql_client.cc sql_crypt.cc
               sql_cursor.cc sql_db.cc sql_delete.cc sql_derived.cc
               sql_digest.cc sql_do.cc
               sql_error.cc sql_handler.cc sql_get_diagnostics.cc
               sql_help.cc sql_insert.cc sql_lex.cc
               sql_list.cc sql_load.cc sql_manager.cc
               sql_oracle_outer_join.cc
               sql_parse.cc sql_bootstrap.cc
               sql_partition.cc sql_plugin.cc sql_prepare.cc sql_rename.cc
               debug_sync.cc debug.cc
               sql_repl.cc sql_select.cc sql_show.cc sql_state.c
               group_by_handler.cc derived_handler.cc select_handler.cc
               sql_statistics.cc sql_string.cc lex_string.h
               sql_table.cc sql_test.cc sql_trigger.cc sql_udf.cc sql_union.cc
               ddl_log.cc ddl_log.h
               sql_update.cc sql_view.cc strfunc.cc table.cc thr_malloc.cc
               sql_time.cc tztime.cc unireg.cc item_xmlfunc.cc
               uniques.cc
               rpl_tblmap.cc sql_binlog.cc event_scheduler.cc
               event_data_objects.cc
               event_queue.cc event_db_repository.cc
               events.cc ../sql-common/my_user.c
               partition_info.cc rpl_utility.cc rpl_utility_server.cc
               rpl_injector.cc sql_locale.cc
               rpl_rli.cc rpl_mi.cc sql_servers.cc sql_audit.cc
               sql_connect.cc scheduler.cc sql_partition_admin.cc
               sql_profile.cc event_parse_data.cc sql_alter.cc
               sql_signal.cc mdl.cc sql_admin.cc
               transaction.cc sys_vars.cc sql_truncate.cc datadict.cc
               sql_reload.cc

               # added in MariaDB:
               grant.cc
               sql_explain.cc
               sql_analyze_stmt.cc
               sql_join_cache.cc
               create_options.cc multi_range_read.cc
               opt_histogram_json.cc
               opt_index_cond_pushdown.cc opt_subselect.cc
               opt_table_elimination.cc sql_expression_cache.cc
               gcalc_slicescan.cc gcalc_tools.cc
               my_apc.cc mf_iocache_encr.cc item_jsonfunc.cc
               my_json_writer.cc json_schema.cc json_schema_helper.cc
               rpl_gtid.cc gtid_index.cc rpl_parallel.cc
               semisync.cc semisync_master.cc semisync_slave.cc
               semisync_master_ack_receiver.cc
               sp_instr.cc
               sql_schema.cc
               lex_charset.cc charset_collations.cc
               sql_type.cc sql_mode.cc sql_type_json.cc
               sql_type_string.cc
               sql_type_geom.cc sql_type_vector.cc
               item_windowfunc.cc sql_window.cc
	       sql_cte.cc
               item_vers.cc
               sql_sequence.cc sql_sequence.h ha_sequence.h
               sql_tvc.cc sql_tvc.h
               opt_split.cc
               rowid_filter.cc rowid_filter.h
               optimizer_costs.h optimizer_defaults.h
               opt_trace.cc
               opt_trace_ddl_info.cc
               table_cache.cc encryption.cc temporary_tables.cc
               json_table.cc
               proxy_protocol.cc backup.cc xa.cc
               socketpair.c socketpair.h
               opt_vcol_substitution.h
               opt_vcol_substitution.cc
               opt_hints_parser.cc opt_hints_parser.h scan_char.h
               opt_hints.cc opt_hints.h
               sql_type_row.cc
               sql_type_composite.cc sql_type_composite.h
               item_composite.cc item_composite.h
               ${CMAKE_CURRENT_BINARY_DIR}/lex_hash.h
               ${CMAKE_CURRENT_BINARY_DIR}/lex_token.h
               ${GEN_SOURCES}
               ${MYSYS_LIBWRAP_SOURCE}
)

MY_CHECK_CXX_COMPILER_FLAG(-Wno-unused-but-set-variable)
IF(have_CXX__Wno_unused_but_set_variable)
  IF(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64"
     AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
     AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9.0")
    # Avoid excessive compile time on RHEL8 aarch64
    SET(ARM_OLD_GCC_FLAGS -fno-strict-aliasing)
  ENDIF()
  ADD_COMPILE_FLAGS(${CMAKE_CURRENT_BINARY_DIR}/yy_mariadb.cc
    ${CMAKE_CURRENT_BINARY_DIR}/yy_oracle.cc
    COMPILE_FLAGS "${ARM_OLD_GCC_FLAGS} -Wno-unused-but-set-variable")
ENDIF()

IF ((CMAKE_SYSTEM_NAME MATCHES "Linux" OR
     CMAKE_SYSTEM_NAME MATCHES "SunOS" OR
     WIN32 OR
     HAVE_KQUEUE)
    AND (NOT DISABLE_THREADPOOL))
 ADD_DEFINITIONS(-DHAVE_POOL_OF_THREADS)
 IF(WIN32)
   SET(SQL_SOURCE ${SQL_SOURCE} threadpool_win.cc threadpool_winsockets.cc threadpool_winsockets.h)
 ENDIF()
 SET(SQL_SOURCE ${SQL_SOURCE} threadpool_generic.cc)
 SET(SQL_SOURCE ${SQL_SOURCE} threadpool_common.cc)
 MYSQL_ADD_PLUGIN(thread_pool_info thread_pool_info.cc DEFAULT STATIC_ONLY NOT_EMBEDDED)
ENDIF()

IF(WIN32)
  SET(SQL_SOURCE ${SQL_SOURCE} handle_connections_win.cc winmain.cc)
ENDIF()

MYSQL_ADD_PLUGIN(partition ha_partition.cc STORAGE_ENGINE DEFAULT STATIC_ONLY
RECOMPILE_FOR_EMBEDDED)
MYSQL_ADD_PLUGIN(sql_sequence ha_sequence.cc STORAGE_ENGINE MANDATORY STATIC_ONLY
RECOMPILE_FOR_EMBEDDED)
MYSQL_ADD_PLUGIN(online_alter_log online_alter.cc STORAGE_ENGINE MANDATORY
STATIC_ONLY NOT_EMBEDDED)


ADD_LIBRARY(sql STATIC ${SQL_SOURCE})
MAYBE_DISABLE_IPO(sql)
DTRACE_INSTRUMENT(sql)
TARGET_LINK_LIBRARIES(sql
  mysys mysys_ssl dbug strings vio pcre2-8
  tpool
  online_alter_log
  ${LIBWRAP} ${LIBCRYPT} ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT}
  ${SSL_LIBRARIES}
  ${LIBSYSTEMD})
IF(TARGET pcre2)
  ADD_DEPENDENCIES(sql pcre2)
ENDIF()

FOREACH(se aria partition perfschema sql_sequence wsrep)
  # These engines are used directly in sql sources.
  IF(TARGET ${se})
    TARGET_LINK_LIBRARIES(sql ${se})
  ENDIF()
ENDFOREACH()

IF(VISIBILITY_HIDDEN_FLAG AND TARGET partition AND WITH_UBSAN)
  # the spider plugin needs some partition symbols from inside mysqld
  # when built with ubsan, in which case we need to remove
  # -fvisibility=hidden from partition
  GET_TARGET_PROPERTY(f partition COMPILE_FLAGS)
  STRING(REPLACE "${VISIBILITY_HIDDEN_FLAG}" "" f ${f})
  SET_TARGET_PROPERTIES(partition PROPERTIES COMPILE_FLAGS "${f}")
ENDIF()

IF(WIN32)
  SET(MYSQLD_SOURCE main.cc  message.rc)
ELSE()
  SET(MYSQLD_SOURCE main.cc ${DTRACE_PROBES_ALL})
ENDIF()

IF(MSVC OR CMAKE_SYSTEM_NAME MATCHES AIX)
  SET(libs_to_export_symbols sql mysys dbug strings)
  # Create shared library of already compiled object
  # Export all symbols from selected libraries, to be used
  # by plugins
  IF(MSVC)
    SET(VERSIONINFO_RC ${PROJECT_BINARY_DIR}/versioninfo_dll.rc)
  ELSE()
    SET(VERSIONINFO_RC)
  ENDIF()
  ADD_LIBRARY(server SHARED
    $<TARGET_OBJECTS:sql>
    $<TARGET_OBJECTS:mysys>
    $<TARGET_OBJECTS:dbug>
    $<TARGET_OBJECTS:strings>
    ${VERSIONINFO_RC}
  )

  # We need to add all dependencies of sql/mysys/dbug/strings
  # to link the shared library
  SET(all_deps)
  FOREACH(lib ${libs_to_export_symbols})
    GET_TARGET_PROPERTY(deps ${lib} LINK_LIBRARIES)
    IF(deps)
      LIST(APPEND all_deps ${deps})
    ENDIF()
  ENDFOREACH()
  LIST(REMOVE_DUPLICATES all_deps)
  FOREACH(lib ${libs_to_export_symbols})
    LIST(REMOVE_ITEM all_deps ${lib})
  ENDFOREACH()

  TARGET_LINK_LIBRARIES(server PRIVATE
   ${all_deps}
   sql_builtins
  )
  IF(MSVC)

=== debian/changelog ===
mariadb (1:12.2.2+maria~ubu2204) jammy; urgency=medium

  * Automatic build with MariaDB build.

 -- MariaDB Developers <developers@lists.mariadb.org>  Fri, 06 Feb 2026 22:05:17 +0000

## mariadb 12.2.2+maria~ubu2404

=== debian/changelog ===
mariadb (1:12.2.2+maria~ubu2404) noble; urgency=medium

  * Automatic build with MariaDB build.

 -- MariaDB Developers <developers@lists.mariadb.org>  Fri, 06 Feb 2026 21:57:45 +0000

## mariadb 12.2.2+maria~ubu2504

=== debian/changelog ===
mariadb (1:12.2.2+maria~ubu2504) plucky; urgency=medium

  * Automatic build with MariaDB build.

 -- MariaDB Developers <developers@lists.mariadb.org>  Fri, 06 Feb 2026 20:48:49 +0000

## mariadb 12.2.2+maria~ubu2510

=== debian/changelog ===
mariadb (1:12.2.2+maria~ubu2510) questing; urgency=medium

  * Automatic build with MariaDB build.

 -- MariaDB Developers <developers@lists.mariadb.org>  Fri, 06 Feb 2026 21:49:18 +0000

## mariadb 12.3.1%2Bmaria~ubu2204

=== debian/changelog ===
mariadb (1:12.3.1+maria~ubu2204) jammy; urgency=medium

  * Automatic build with MariaDB build.

 -- MariaDB Developers <developers@lists.mariadb.org>  Tue, 10 Feb 2026 12:13:58 +0000

mariadb (1:12.3.0) unstable; urgency=medium

  * Initial Release

 -- Sergei Golubchik <serg@mariadb.org> Mon Aug  4 21:26:56 CEST 2025

## mariadb 12.3.1+maria~deb11

=== CMakeLists.txt ===
# Copyright (c) 2006, 2017, Oracle and/or its affiliates.
# Copyright (c) 2008, 2022, MariaDB Corporation.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1335 USA

CMAKE_MINIMUM_REQUIRED(VERSION 3.12.0)

IF(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  # Setting build type to RelWithDebInfo as none was specified.
  # Must occur before PROJECT
  SET(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
   "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel"
   FORCE)
  # Set the possible values of build type for cmake-gui
  SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
   "None" "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
ENDIF()

# Remove the following comment if you don't want to have striped binaries
# in RPM's:

#set(CPACK_RPM_SPEC_MORE_DEFINE "%define __spec_install_post /bin/true")
FOREACH(p CMP0022 CMP0046 CMP0040 CMP0048 CMP0054 CMP0056 CMP0067 CMP0074 CMP0075 CMP0069 CMP0135 CMP0091)
  IF(POLICY ${p})
    CMAKE_POLICY(SET ${p} NEW)
  ENDIF()
ENDFOREACH()

PROJECT(MariaDB)

MESSAGE(STATUS "Running cmake version ${CMAKE_VERSION}")

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
  ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_SOURCE_DIR}/cmake/Internal/CPack)

# Use a default manufacturer if no manufacturer was identified.
IF(NOT DEFINED MANUFACTURER) 
  SET(MANUFACTURER "Built from Source" CACHE  STRING
     "Set the entity that appears as the manufacturer of packages that support a manufacturer field.")
  MARK_AS_ADVANCED(MANUFACTURER)
ENDIF()

# MAX_INDEXES - Set the maximum number of indexes per table, default 64
SET(MAX_INDEXES 64 CACHE STRING "Max number of indexes")
IF (${MAX_INDEXES} GREATER 128)
  MESSAGE(FATAL_ERROR "MAX_INDEXES values greater than 128 is not supported!")
ENDIF()

IF(UNIX AND NOT APPLE)
  # Note, that generally one should not change settings depending
  # on CMAKE_BUILD_TYPE, because VS and Xcode configure once (with
  # the empty CMAKE_BUILD_TYPE) and the build many times for
  # different build types without re-running cmake!
  # But we only care about WITH_PIC on Unix, where the check for
  # CMAKE_BUILD_TYPE hapen to work.
  IF (CMAKE_BUILD_TYPE MATCHES "Debug")
    SET(WITH_PIC_DEFAULT ON)
  ELSE()
    SET(WITH_PIC_DEFAULT OFF)
  ENDIF()
  # Compiling with PIC speeds up embedded build, on PIC sensitive systems 
  # Predefine it to OFF in release builds, because of the performance penalty
  SET(WITH_PIC ${WITH_PIC_DEFAULT} CACHE BOOL "Compile with PIC.")
  MARK_AS_ADVANCED(WITH_PIC)
ENDIF()

# This is used by TokuDB only
SET(MYSQL_PROJECT_NAME_DOCSTRING "MySQL project name")

# C and C++ standards (e.g. -std=c++17)
SET(CMAKE_C_STANDARD 99)
SET(CMAKE_CXX_STANDARD 17)

# Lower case package names from PROJECT are used if not explictly upper case.
SET(CPACK_PACKAGE_NAME "MariaDB")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "MariaDB: a very fast and robust SQL database server")
SET(CPACK_PACKAGE_URL "http://mariadb.org")

IF(BUILD_CONFIG)
  INCLUDE(
  ${CMAKE_SOURCE_DIR}/cmake/build_configurations/${BUILD_CONFIG}.cmake)
ENDIF()

# Include the platform-specific file. To allow exceptions, this code
# looks for files in order of how specific they are. If there is, for
# example, a generic Linux.cmake and a version-specific
# Linux-2.6.28-11-generic, it will pick Linux-2.6.28-11-generic and
# include it. It is then up to the file writer to include the generic
# version if necessary.
FOREACH(_base
    ${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_VERSION}-${CMAKE_SYSTEM_PROCESSOR}
    ${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_VERSION}
    ${CMAKE_SYSTEM_NAME})
  SET(_file ${CMAKE_SOURCE_DIR}/cmake/os/${_base}.cmake)
  IF(EXISTS ${_file})
    INCLUDE(${_file})
    BREAK()
  ENDIF()
ENDFOREACH()

IF(NOT RPM AND NOT DEB)
FOREACH(tool gtar tar)
 STRING(TOUPPER ${tool}  TOOL)
 FIND_PROGRAM(${TOOL}_EXECUTABLE ${tool} DOC "path to the executable")
 MARK_AS_ADVANCED(${TOOL}_EXECUTABLE)
ENDFOREACH()
ENDIF()

FIND_PACKAGE(Git)

IF(WIN32 AND (CMAKE_VERSION VERSION_GREATER "3.21"))
 OPTION(INSTALL_RUNTIME_DEPENDENCIES "Install runtime dependencies" ON)
ENDIF()

# Following autotools tradition, add preprocessor definitions
# specified in environment variable CPPFLAGS
IF(DEFINED ENV{CPPFLAGS})
  ADD_DEFINITIONS($ENV{CPPFLAGS})
ENDIF()

# NUMA
SET(WITH_NUMA "AUTO" CACHE STRING "Build with non-uniform memory access, allowing --innodb-numa-interleave. Options are ON|OFF|AUTO. ON = enabled (requires NUMA library), OFF = disabled, AUTO = enabled if NUMA library found.")

SET(MYSQL_MAINTAINER_MODE "AUTO" CACHE STRING "Enable MariaDB maintainer-specific warnings. One of: NO (warnings are disabled) WARN (warnings are enabled) ERR (warnings are errors) AUTO (warnings are errors in Debug only)")

# Packaging
IF (NOT CPACK_GENERATOR)
  IF(WIN32)
    SET(CPACK_GENERATOR "ZIP")
  ELSE()
    SET(CPACK_GENERATOR "TGZ")
  ENDIF(WIN32) 
ENDIF(NOT CPACK_GENERATOR)

INCLUDE(FeatureSummary)
INCLUDE(misc)
INCLUDE(mysql_version)
INCLUDE(cpack_source_ignore_files)
INCLUDE(install_layout)
INCLUDE(submodules)

# Add macros
INCLUDE(character_sets)
INCLUDE(cpu_info)
INCLUDE(zlib)
INCLUDE(ssl)
INCLUDE(readline)
INCLUDE(libutils)
INCLUDE(dtrace)
INCLUDE(pcre)
INCLUDE(libfmt)
INCLUDE(ctest)
INCLUDE(plugin)
INCLUDE(install_macros)
INCLUDE(systemd)
INCLUDE(mysql_add_executable)
INCLUDE(symlinks)
INCLUDE(compile_flags)

# Handle options
OPTION(DISABLE_SHARED 
 "Don't build shared libraries, compile code as position-dependent" OFF)
IF(DISABLE_SHARED)
  SET(WITHOUT_DYNAMIC_PLUGINS 1)
ENDIF()
OPTION(ENABLED_PROFILING "Enable profiling" ON)
OPTION(ENABLED_JSON_WRITER_CONSISTENCY_CHECKS "Enable Json_writer_object / Json_writer_array checking to produce consistent JSON output" OFF)
IF(ENABLED_JSON_WRITER_CONSISTENCY_CHECKS)
  ADD_DEFINITIONS(-DENABLED_JSON_WRITER_CONSISTENCY_CHECKS)
ENDIF()
OPTION(WITHOUT_SERVER "Build only the client library and clients" OFF)
IF(UNIX)
  OPTION(WITH_VALGRIND "Valgrind instrumentation" OFF)
ENDIF()
OPTION (WITH_UNIT_TESTS "Compile MySQL with unit tests" ON)

IF (WITHOUT_SERVER)
  SET (SKIP_COMPONENTS "Server|IniFiles|SupportFiles|Readme")
ELSE()
  SET (SKIP_COMPONENTS "N-O-N-E")
ENDIF()


SET(MEMPROTECT_DEFAULT ON)

OPTION(WITH_PROTECT_STATEMENT_MEMROOT "Enable protection of statement's memory root after first SP/PS execution. Turned into account only for debug build"
${MEMPROTECT_DEFAULT})

#
#  Enable protection of statement's memory root after first SP/PS execution.
#  Can be switched on only for debug build.
#
IF (WITH_PROTECT_STATEMENT_MEMROOT)
  SET(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DPROTECT_STATEMENT_MEMROOT")
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DPROTECT_STATEMENT_MEMROOT")
ENDIF()

INCLUDE(check_compiler_flag)
INCLUDE(check_linker_flag)

OPTION(WITH_ASAN "Enable address sanitizer" OFF)

IF (WITH_ASAN AND NOT MSVC)
  # this flag might be set by default on some OS
  MY_CHECK_AND_SET_COMPILER_FLAG("-U_FORTIFY_SOURCE" DEBUG RELWITHDEBINFO)
  MY_CHECK_AND_SET_COMPILER_FLAG("-fsanitize=address -fPIC"
    DEBUG RELWITHDEBINFO)
  SET(HAVE_C_FSANITIZE ${have_C__fsanitize_address__fPIC})
  SET(HAVE_CXX_FSANITIZE ${have_CXX__fsanitize_address__fPIC})
  IF(HAVE_C_FSANITIZE AND HAVE_CXX_FSANITIZE)
    OPTION(WITH_ASAN_SCOPE "Enable -fsanitize-address-use-after-scope" OFF)
    SET(WITH_ASAN_OK 1)
    IF(WITH_ASAN_SCOPE)
      MY_CHECK_AND_SET_COMPILER_FLAG(
        "-fsanitize=address -fsanitize-address-use-after-scope"
	DEBUG RELWITHDEBINFO)
    ENDIF()
  ENDIF()

  IF(NOT WITH_ASAN_OK)
    MESSAGE(FATAL_ERROR "Do not know how to enable address sanitizer")
  ENDIF()
ENDIF()

OPTION(WITH_TSAN "Enable thread sanitizer" OFF)
IF (WITH_TSAN)
  MY_CHECK_AND_SET_COMPILER_FLAG("-fsanitize=thread" DEBUG RELWITHDEBINFO)
ENDIF()

OPTION(WITH_UBSAN "Enable undefined behavior sanitizer" OFF)
IF (WITH_UBSAN)
  MY_CHECK_AND_SET_COMPILER_FLAG("-fsanitize=undefined -fno-sanitize=alignment -U_FORTIFY_SOURCE -DWITH_UBSAN" DEBUG RELWITHDEBINFO)
ENDIF()

OPTION(WITH_MSAN "Enable memory sanitizer" OFF)
IF (WITH_MSAN)
  MY_CHECK_AND_SET_COMPILER_FLAG("-fsanitize=memory -fsanitize-memory-track-origins -U_FORTIFY_SOURCE")
  IF (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "20.0")
    # workaround for https://github.com/llvm/llvm-project/issues/179605
    SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O1")
  ENDIF()
  IF(NOT (have_C__fsanitize_memory__fsanitize_memory_track_origins__U_FORTIFY_SOURCE
          AND have_CXX__fsanitize_memory__fsanitize_memory_track_origins__U_FORTIFY_SOURCE))
    MESSAGE(FATAL_ERROR "Compiler doesn't support -fsanitize=memory flags")
  ENDIF()
  MY_CHECK_CXX_COMPILER_FLAG("-stdlib=libc++")
  IF(NOT have_CXX__stdlib_libc__)
    MESSAGE(FATAL_ERROR "C++ Compiler requires support for -stdlib=libc++")
  ENDIF()
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
  MY_CHECK_AND_SET_LINKER_FLAG("-fsanitize=memory")
  IF(NOT HAVE_LINK_FLAG__fsanitize_memory)
    MESSAGE(FATAL_ERROR "Linker doesn't support -fsanitize=memory flags")
  ENDIF()
ENDIF()

OPTION(WITH_GPROF "Enable profiling with gprof" OFF)
IF (WITH_GPROF)
  MY_CHECK_AND_SET_COMPILER_FLAG("-pg -g -no-pie -fPIC")
ENDIF()

# Be nice to profilers etc
MY_CHECK_AND_SET_COMPILER_FLAG("-fno-omit-frame-pointer" RELWITHDEBINFO)

# enable security hardening features, like most distributions do
# in our benchmarks that costs about ~1% of performance, depending on the load
OPTION(SECURITY_HARDENED "Use security-enhancing compiler features (stack protector, relro, etc)" ON)
IF(SECURITY_HARDENED AND NOT WITH_ASAN AND NOT WITH_UBSAN AND NOT WITH_TSAN AND NOT WITH_GPROF AND NOT WITH_MSAN)
  # security-enhancing flags
  MY_CHECK_AND_SET_COMPILER_FLAG("-pie -fPIC")
  MY_CHECK_AND_SET_LINKER_FLAG("-Wl,-z,relro,-z,now")
  MY_CHECK_AND_SET_COMPILER_FLAG("-fstack-protector --param=ssp-buffer-size=4")
  MY_CHECK_AND_SET_COMPILER_FLAG("-D_FORTIFY_SOURCE=2" RELEASE RELWITHDEBINFO)
ENDIF()

OPTION(WITH_DBUG_TRACE "Enable DBUG_ENTER()/DBUG_RETURN()/DBUG_PRINT()" ON)
IF(WITH_DBUG_TRACE)
  FOREACH(LANG C CXX)
    SET(CMAKE_${LANG}_FLAGS_DEBUG "${CMAKE_${LANG}_FLAGS_DEBUG} -DDBUG_TRACE")
  ENDFOREACH()
ENDIF()

# Always enable debug sync for debug builds.
SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DENABLED_DEBUG_SYNC")
SET(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DENABLED_DEBUG_SYNC")

IF(CMAKE_C_COMPILER_ID STREQUAL "GNU" AND NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "10")
  # Enable extra checks when using a recent enough version of GNU libstdc++
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_GLIBCXX_DEBUG -D_GLIBCXX_ASSERTIONS")
ENDIF()

OPTION(ENABLE_GCOV "Enable gcov (debug, macOS and Linux builds only)" OFF)
IF (ENABLE_GCOV)
  IF (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
    MY_CHECK_AND_SET_COMPILER_FLAG("--coverage" DEBUG)
  ELSE()
    MY_CHECK_AND_SET_COMPILER_FLAG("-DHAVE_gcov -fprofile-arcs -ftest-coverage -lgcov" DEBUG)
  ENDIF()
ENDIF()

OPTION(WITHOUT_PACKED_SORT_KEYS "disable packed sort keys"  OFF)
IF(WITHOUT_PACKED_SORT_KEYS)
  ADD_DEFINITIONS(-DWITHOUT_PACKED_SORT_KEYS)
ENDIF()

MY_CHECK_AND_SET_COMPILER_FLAG(-ggdb3 DEBUG)

SET(ENABLED_LOCAL_INFILE "AUTO" CACHE STRING "If we should should enable LOAD DATA LOCAL by default (OFF/ON/AUTO)")
IF (ENABLED_LOCAL_INFILE MATCHES "^(0|FALSE)$")
  SET(ENABLED_LOCAL_INFILE OFF)
ELSEIF(ENABLED_LOCAL_INFILE MATCHES "^(1|TRUE)$")

=== debian/changelog ===
mariadb (1:12.3.1+maria~deb11) bullseye; urgency=medium

  * Automatic build with MariaDB build.

 -- MariaDB Developers <developers@lists.mariadb.org>  Tue, 10 Feb 2026 11:14:30 +0000

=== debian/control ===
Source: mariadb
Section: database
Priority: optional
Maintainer: MariaDB Developers <developers@lists.mariadb.org>
Build-Depends:
 debhelper (>= 11),
 dh-exec,
 bison,
 cmake,
 cracklib-runtime <!nocheck>,
 default-jdk,
 flex [amd64 arm64],
 gdb <!nocheck>,
 libaio-dev [linux-any],
 libboost-atomic-dev [amd64 arm64],
 libboost-chrono-dev [amd64 arm64],
 libboost-date-time-dev [amd64 arm64],
 libboost-dev,
 libboost-filesystem-dev [amd64 arm64],
 libboost-regex-dev [amd64 arm64],
 libboost-system-dev [amd64 arm64],
 libboost-thread-dev [amd64 arm64],
 libbz2-dev,
 libcrack2-dev (>= 2.9.0),
 libcurl4-openssl-dev | libcurl4-dev,
 libedit-dev,
 libedit-dev:native,
 libfmt-dev (>= 7.0.0),
 libjemalloc-dev [linux-any],
 libjudy-dev,
 libkrb5-dev,
 liblz4-dev,
 liblzma-dev,
 liblzo2-dev,
 libncurses-dev,
 libnuma-dev [linux-any],
 libpam0g-dev,
 libpcre2-dev,
 libsnappy-dev,
 libssl-dev,
 libssl-dev:native,
 libsystemd-dev [linux-any],
 liburing-dev [linux-any],
 libxml2-dev,
 libzstd-dev (>= 1.1.3),
 lsb-release,
 perl:any,
 po-debconf,
 psmisc,
 unixodbc-dev,
 uuid-dev,
 zlib1g-dev (>= 1:1.1.3-5~),
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://mariadb.org/
Vcs-Browser: https://github.com/MariaDB/server/
Vcs-Git: https://github.com/MariaDB/server.git

Package: libmariadb-dev
Architecture: any
Section: libdevel
Depends:
 libmariadb3 (= ${binary:Version}),
 libssl-dev,
 zlib1g-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libmariadb-dev-compat (<< 3.0.0),
 libmariadbclient-dev,
 libmariadbclient16-dev,
Provides:
 libmariadbclient-dev,
Breaks:
 libmariadb-client-lgpl-dev,
 libmysqlclient-dev (<< ${source:Version}),
 libmysqld-dev (<< ${source:Version}),
Replaces:
 libmariadb-client-lgpl-dev,
 libmariadb-dev-compat (<< 3.0.0),
 libmariadbclient-dev,
 libmysqlclient-dev (<< ${source:Version}),
 libmysqld-dev (<< ${source:Version}),
Description: MariaDB database development files
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes development libraries and header files to allow sources
 expecting the MariaDB Connector/C to build. Sources that expect the MySQL
 client libraries should use files from the libmariadb-dev-compat package.

Package: libmariadb-dev-compat
Architecture: any
Section: libdevel
Depends:
 libmariadb-dev (= ${binary:Version}),
 ${misc:Depends},
Conflicts:
 libmariadb-client-lgpl-dev,
 libmariadb-client-lgpl-dev-compat,
 libmariadbclient-dev (<< ${source:Version}),
 libmariadbclient-dev-compat,
 libmysqlclient-dev,
 libmysqlclient10-dev,
 libmysqlclient12-dev,
 libmysqlclient14-dev,
 libmysqlclient15-dev,
 libmysqlclient16-dev,
Provides:
 libmariadb-client-lgpl-dev-compat,
 libmariadbclient-dev-compat,
 libmysqlclient-dev,
Breaks:
 libmariadb-dev (<< ${source:Version}),
Replaces:
 libmariadb-client-lgpl-dev,
 libmariadb-client-lgpl-dev-compat,
 libmariadb-dev (<< ${source:Version}),
 libmariadbclient-dev (<< ${source:Version}),
 libmariadbclient-dev-compat,
 libmysqlclient-dev,
Description: MariaDB Connector/C, compatibility symlinks
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes compatibility symlinks to allow sources expecting the
 MySQL client libraries to be built against MariaDB Connector/C.

Package: libmariadb3
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 mariadb-common,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libmariadbclient18 (<< 10.2.0),
 mariadb-galera-server-10.0,
 mariadb-galera-server-5.5,
 mariadb-server-10.0,
 mariadb-server-5.1,
 mariadb-server-5.2,
 mariadb-server-5.3,
 mariadb-server-5.5,
Breaks:
 libmariadbclient18 (<< ${source:Version}),
Replaces:
 libmariadbclient18 (<< ${source:Version}),
Description: MariaDB database client library
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the client library.

Package: libmariadb3-compat
Architecture: any
Section: libs
Depends:
 libmariadb3,
 mariadb-common,
 ${misc:Depends},
Breaks:
 libmysqlclient19,
 libmysqlclient20,
 libmysqlclient21,
Replaces:
 libmysqlclient19,
 libmysqlclient20,
 libmysqlclient21,
Provides:
 libmysqlclient19,
 libmysqlclient20,
 libmysqlclient21,
Description: MariaDB database client library MySQL compat package
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the client runtime libraries that simulate and replace
 the equivalents found in MySQL 5.6, 5.7 and 8.0 (mysqlclient19, 20 and 21).

Package: libmariadbclient18
Section: libs
Architecture: any
Depends:
 libmariadb3 (= ${binary:Version}),
 ${misc:Depends},
Replaces:
 libmariadbclient18,
Provides:
 libmariadbclient18,
Description: Virtual package to satisfy external libmariadbclient18 depends
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package provides compatibility symlinks for binaries that expect to find
 libmariadbclient.so.18 will automatically use libmariadb.so.3 instead.

Package: libmysqlclient18
Section: libs
Architecture: any
Depends:
 libmariadb3 (= ${binary:Version}),
 ${misc:Depends},
Replaces:
 libmysqlclient18,
Provides:
 libmysqlclient18,
Description: Virtual package to satisfy external libmysqlclient18 depends
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package provides compatibility symlinks for binaries that expect to find
 libmysqlclient.so.18 will automatically use libmariadb.so.3 instead.

Package: libmariadbd19
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libmariadbd-dev (<< ${source:Version}),
Conflicts:
 libmariadbd19t64,
Replaces:
 libmariadbd-dev (<< ${source:Version}),
Multi-Arch: same
Description: MariaDB embedded database, shared library
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes a shared library for embedded MariaDB applications.

Package: libmariadbd-dev
Architecture: any
Section: libdevel
Provides:
 libmysqld-dev,
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libmariadb-dev (= ${binary:Version}),
 libmariadbd19 (= ${binary:Version}),
 ${misc:Depends},
Breaks:
 libmariadb-dev (<< ${source:Version}),
 libmariadbclient-dev (<< ${source:Version}),
 libmysqld-dev,
Replaces:
 libmariadb-dev (<< ${source:Version}),
 libmariadbclient-dev (<< ${source:Version}),
 libmysqld-dev,
Description: MariaDB embedded database, development files package
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the MariaDB embedded server library development
 and header files.

Package: mysql-common
Architecture: all
Depends:
 ${misc:Depends},
Description: MariaDB client common configuration files package (e.g. /etc/mysql/my.cnf)
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes files needed by all versions of the client library
 (e.g. /etc/mysql/my.cnf).

Package: mariadb-common
Architecture: all
Depends:
 mysql-common (>= 5.6.25),
 ${misc:Depends},
Multi-Arch: foreign
Description: MariaDB database common files (e.g. /etc/mysql/mariadb.conf.d/)
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes configuration files common to all MariaDB programs.

Package: mariadb-client-core
Architecture: any
Depends:
 libmariadb3 (>= 10.5.4),
 mariadb-common (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 mariadb-client-10.0,
 mariadb-client-10.1,
 mariadb-client-10.2,
 mariadb-client-10.3,
 mariadb-client-10.4,
 mariadb-client-10.5,
 mariadb-client-10.6,
 mariadb-client-10.7,
 mariadb-client-10.8,
 mariadb-client-5.1,
 mariadb-client-5.2,
 mariadb-client-5.3,
 mariadb-client-5.5,
 mariadb-client-core-10.0,
 mariadb-client-core-10.1,
 mariadb-client-core-10.2,
 mariadb-client-core-10.3,
 mariadb-client-core-10.4,
 mariadb-client-core-10.5,
 mariadb-client-core-10.6,
 mariadb-client-core-10.7,
 mariadb-client-core-10.8,
 mariadb-client-core-5.1,
 mariadb-client-core-5.2,
 mariadb-client-core-5.3,
 mariadb-client-core-5.5,
 mysql-client (<< 5.0.51),
 mysql-client-5.0,
 mysql-client-5.1,
 mysql-client-5.5,
 mysql-client-core-5.1,
 mysql-client-core-5.5,
 mysql-client-core-5.6,
 mysql-client-core-5.7,
 mysql-client-core-8.0,
 virtual-mysql-client-core,
Breaks:
 mariadb-client (<< ${source:Version}),
 mariadb-server-10.0,
 mariadb-server-10.1,
 mariadb-server-core (<< ${source:Version}),
 mariadb-server-core-10.0,
 mariadb-server-core-10.1,
 mariadb-server-core-10.2,
 mariadb-server-core-10.3,
 mariadb-server-core-10.4,
 mariadb-server-core-10.5,
 mariadb-server-core-10.6,
 mariadb-server-core-10.7,
 mariadb-server-core-10.8,
 mysql-cluster-community-client-plugins,
 mysql-server-core-5.5,
 mysql-server-core-5.6,
 mysql-server-core-5.7,
 mysql-server-core-8.0,
 percona-server-server-5.6,
 percona-server-server-5.7,
 percona-server-server-8.0,
 percona-xtradb-cluster-server-5.6,
 percona-xtradb-cluster-server-5.7,
 percona-xtradb-cluster-server-8.0,
Replaces:
 mariadb-client (<< ${source:Version}),
 mariadb-client-10.0,
 mariadb-client-10.1,
 mariadb-client-10.2,
 mariadb-client-10.3,
 mariadb-client-10.4,
 mariadb-client-10.5,
 mariadb-client-10.6,
 mariadb-client-10.7,
 mariadb-client-10.8,
 mariadb-client-5.1,
 mariadb-client-5.2,
 mariadb-client-5.3,
 mariadb-client-5.5,
 mariadb-client-core-10.0,
 mariadb-client-core-10.1,
 mariadb-client-core-10.2,
 mariadb-client-core-10.3,
 mariadb-client-core-10.4,
 mariadb-client-core-10.5,
 mariadb-client-core-10.6,
 mariadb-client-core-10.7,
 mariadb-client-core-10.8,
 mariadb-client-core-5.1,
 mariadb-client-core-5.2,
 mariadb-client-core-5.3,
 mariadb-client-core-5.5,
 mariadb-server-10.0,
 mariadb-server-10.1,
 mariadb-server-core (<< ${source:Version}),
 mariadb-server-core-10.0,
 mariadb-server-core-10.1,
 mariadb-server-core-10.2,
 mariadb-server-core-10.3,
 mariadb-server-core-10.4,
 mariadb-server-core-10.5,
 mariadb-server-core-10.6,
 mariadb-server-core-10.7,
 mariadb-server-core-10.8,
 mysql-client (<< 5.0.51),
 mysql-client-5.0,
 mysql-client-5.1,
 mysql-client-5.5,
 mysql-client-core-5.1,
 mysql-client-core-5.5,
 mysql-client-core-5.6,
 mysql-client-core-5.7,
 mysql-client-core-8.0,
 mysql-cluster-community-client-plugins,

## mariadb 12.3.1+maria~debsid

=== client/CMakeLists.txt ===
# Copyright (c) 2006, 2015, Oracle and/or its affiliates. All rights reserved.
# Copyright (c) 2008, 2019, MariaDB Corporation
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1335 USA

INCLUDE_DIRECTORIES(
  ${CMAKE_SOURCE_DIR}/include
  ${PCRE_INCLUDE_DIRS}
  ${CMAKE_SOURCE_DIR}/mysys_ssl
  ${ZLIB_INCLUDE_DIRS}
  ${SSL_INCLUDE_DIRS}
  ${CMAKE_SOURCE_DIR}/sql
  ${CMAKE_SOURCE_DIR}/strings
  ${MY_READLINE_INCLUDE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)

INCLUDE_DIRECTORIES(BEFORE
  ${CMAKE_BINARY_DIR}/libmariadb/include
  ${CMAKE_SOURCE_DIR}/libmariadb/include)

## We will need libeay32.dll and ssleay32.dll when running client executables.
COPY_OPENSSL_DLLS(copy_openssl_client)

SET(CLIENT_LIB mariadbclient mysys)

ADD_DEFINITIONS(${SSL_DEFINES})
MYSQL_ADD_EXECUTABLE(mariadb completion_hash.cc mysql.cc readline.cc
                           ${CMAKE_SOURCE_DIR}/sql/sql_string.cc)
TARGET_LINK_LIBRARIES(mariadb ${CLIENT_LIB})
IF(UNIX)
  TARGET_LINK_LIBRARIES(mariadb ${MY_READLINE_LIBRARY})
  SET_TARGET_PROPERTIES(mariadb PROPERTIES ENABLE_EXPORTS TRUE)
ENDIF(UNIX)

MYSQL_ADD_EXECUTABLE(mariadb-test mysqltest.cc ${CMAKE_SOURCE_DIR}/sql/sql_string.cc COMPONENT Test)
SET_SOURCE_FILES_PROPERTIES(mysqltest.cc PROPERTIES COMPILE_FLAGS "-DTHREADS ${PCRE2_DEBIAN_HACK}")
TARGET_LINK_LIBRARIES(mariadb-test  ${CLIENT_LIB} pcre2-posix pcre2-8)
SET_TARGET_PROPERTIES(mariadb-test PROPERTIES ENABLE_EXPORTS TRUE)


MYSQL_ADD_EXECUTABLE(mariadb-check mysqlcheck.c)
TARGET_LINK_LIBRARIES(mariadb-check ${CLIENT_LIB})

MYSQL_ADD_EXECUTABLE(mariadb-dump mysqldump.cc ../sql-common/my_user.c connection_pool.cc)
TARGET_LINK_LIBRARIES(mariadb-dump ${CLIENT_LIB})

ADD_LIBRARY(import_util STATIC import_util.cc import_util.h)
IF (PCRE2_DEBIAN_HACK)
  SET_SOURCE_FILES_PROPERTIES(import_util.cc PROPERTIES COMPILE_FLAGS "${PCRE2_DEBIAN_HACK}")
ENDIF()
TARGET_LINK_LIBRARIES(import_util PRIVATE pcre2-posix pcre2-8)
TARGET_INCLUDE_DIRECTORIES(import_util PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

MYSQL_ADD_EXECUTABLE(mariadb-import mysqlimport.cc)
TARGET_LINK_LIBRARIES(mariadb-import PRIVATE tpool_min ${CLIENT_LIB} import_util)


MYSQL_ADD_EXECUTABLE(mariadb-upgrade mysql_upgrade.c COMPONENT Server)
TARGET_LINK_LIBRARIES(mariadb-upgrade ${CLIENT_LIB})
ADD_DEPENDENCIES(mariadb-upgrade GenFixPrivs)

MYSQL_ADD_EXECUTABLE(mariadb-show mysqlshow.c)
TARGET_LINK_LIBRARIES(mariadb-show ${CLIENT_LIB})

MYSQL_ADD_EXECUTABLE(mariadb-plugin mysql_plugin.c)
TARGET_LINK_LIBRARIES(mariadb-plugin ${CLIENT_LIB})

MYSQL_ADD_EXECUTABLE(mariadb-binlog mysqlbinlog.cc mysqlbinlog-engine.cc)
TARGET_LINK_LIBRARIES(mariadb-binlog ${CLIENT_LIB} mysys_ssl)

MYSQL_ADD_EXECUTABLE(mariadb-admin mysqladmin.cc ../sql/password.c)
TARGET_LINK_LIBRARIES(mariadb-admin ${CLIENT_LIB} mysys_ssl)

MYSQL_ADD_EXECUTABLE(mariadb-slap mysqlslap.c)
SET_SOURCE_FILES_PROPERTIES(mysqlslap.c PROPERTIES COMPILE_FLAGS "-DTHREADS")
TARGET_LINK_LIBRARIES(mariadb-slap ${CLIENT_LIB})

MYSQL_ADD_EXECUTABLE(mariadb-conv mariadb-conv.cc
                     ${CMAKE_SOURCE_DIR}/sql/sql_string.cc)
TARGET_LINK_LIBRARIES(mariadb-conv mysys strings)

IF(WIN32)
  MYSQL_ADD_EXECUTABLE(echo echo.c COMPONENT Test)
ENDIF(WIN32)

# async_example is just a code example, do not install it.
ADD_EXECUTABLE(async_example async_example.c)
TARGET_LINK_LIBRARIES(async_example ${CLIENT_LIB})

SET_TARGET_PROPERTIES (mariadb-check mariadb-dump mariadb-import mariadb-upgrade mariadb-show mariadb-slap mariadb-plugin async_example
PROPERTIES HAS_CXX TRUE)

FOREACH(t mariadb mariadb-test mariadb-check mariadb-dump mariadb-import mariadb-upgrade mariadb-show mariadb-plugin mariadb-binlog
  mariadb-admin mariadb-slap async_example)
  ADD_DEPENDENCIES(${t} GenError ${CLIENT_LIB})
ENDFOREACH()

ADD_DEFINITIONS(-DHAVE_DLOPEN)
IF(WITH_UNIT_TESTS)
  ADD_SUBDIRECTORY(${PROJECT_SOURCE_DIR}/unittest/client ${PROJECT_BINARY_DIR}/unittest/client)
ENDIF()

=== debian/changelog ===
mariadb (1:12.3.1+maria~debsid) sid; urgency=medium

  * Automatic build with MariaDB build.

 -- MariaDB Developers <developers@lists.mariadb.org>  Tue, 10 Feb 2026 13:17:53 +0000

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Build-Depends:
  debhelper (>= 11),
  dh-exec,
+ dh-package-notes,
  bison,
  cmake,
  cracklib-runtime <!nocheck>,
@@ -419,4 +420,3 @@
  mysql-client-core-5.6,
  mysql-client-core-5.7,
  mysql-client-core-8.0,
- mysql-cluster-community-client-plugins,

=== debian/tests/control ===
Tests:
 smoke,
# RocksDB is not built for all archs. Rather than duplicating the condition
# for its existence (see the list in debian/control), install it if available
# and check in the test if it's functional when it should be.
# The plugin package also already depends on the other one.
Depends:
 mariadb-plugin-provider-bzip2,
 mariadb-plugin-provider-lz4,
 mariadb-plugin-provider-lzma,
 mariadb-plugin-provider-lzo,
 mariadb-plugin-provider-snappy,
 mariadb-plugin-rocksdb | mariadb-server,
Restrictions:
 allow-stderr,
 isolation-container,
 needs-root,

Tests:
 upstream,
Depends:
 eatmydata,
 mariadb-test,
Restrictions:
 allow-stderr,
 breaks-testbed,

## mariadb kernel-0.1.0

=== requirements.txt ===
pandas
json2html
matplotlib
lxml
setuptools
setuptools-scm

=== binder/requirements.txt ===
git+https://github.com/MariaDB/mariadb_kernel.git

## mariadb kernel-0.1.1

=== requirements.txt ===
pandas
json2html
matplotlib
lxml
setuptools
setuptools-scm
ipykernel
beautifulsoup4

## mariadb kernel-0.2.0

=== requirements.txt ===
--- 
+++ 
@@ -6,3 +6,4 @@
 setuptools-scm
 ipykernel
 beautifulsoup4
+mycli

=== binder/requirements.txt ===
git+https://github.com/MariaDB/mariadb_kernel.git
